//-----------------------------------------------------------------------------
//
// Title       : No Title
// Design      : lab3-debug
// Author      : cse
// Company     : uw
//
//-----------------------------------------------------------------------------
//
// File        : V:\Code School\CSE378\svndb\lab3-debug\compile\cpu.v
// Generated   : Wed Apr 25 17:37:18 2007
// From        : V:\Code School\CSE378\svndb\lab3-debug\src\cpu.bde
// By          : Bde2Verilog ver. 2.01
//
//-----------------------------------------------------------------------------
//
// Description : 
//
//-----------------------------------------------------------------------------

`ifdef _VCP
`else
`define library
`endif


// ---------- Design Unit Header ---------- //
`timescale 1ps / 1ps

module cpu (CLK,RESET,CPUDataIn,Inst,Load,Overflow,SignedLoad,Store,Zilch,ALUOut,
CPUDataOut,MemSize,PCOut) ;

// ------------ Port declarations --------- //
input CLK;
wire CLK;
input RESET;
wire RESET;
input [31:0] CPUDataIn;
wire [31:0] CPUDataIn;
input [31:0] Inst;
wire [31:0] Inst;
output Load;
wire Load;
output Overflow;
wire Overflow;
output SignedLoad;
wire SignedLoad;
output Store;
wire Store;
output Zilch;
wire Zilch;
output [31:0] ALUOut;
wire [31:0] ALUOut;
output [31:0] CPUDataOut;
wire [31:0] CPUDataOut;
output [1:0] MemSize;
wire [1:0] MemSize;
output [31:0] PCOut;
wire [31:0] PCOut;

// ----------- Signal declarations -------- //
wire Always;
wire EX_JAL;
wire EX_Load;
wire EX_RegWrite;
wire EX_SignedLoad;
wire EX_SrcASel;
wire EX_SrcBSel;
wire EX_Store;
wire Fwd_ID_RS;
wire Fwd_ID_RT;
wire IDEXReg_Clear;
wire ID_Branch;
wire ID_EQ;
wire ID_JAL;
wire ID_JR;
wire ID_Jump;
wire ID_Load;
wire ID_RegWrite;
wire ID_SignedLoad;
wire ID_SrcASel;
wire ID_SrcBSel;
wire ID_Store;
wire ID_WriteToRD;
wire LoadEnable;
wire MEM_Load;
wire MEM_RegWrite;
wire MEM_SignedLoad;
wire MEM_Store;
supply1 VCC;
wire WB_Load;
wire WB_RegWrite;
wire [31:0] AluA;
wire [31:0] AluB;
wire [4:0] ALUCtl;
wire [31:0] BUS814;
wire [4:0] BUS839;
wire [1:0] EX_ALUOp;
wire [31:0] EX_ALUOut;
wire [31:0] EX_ExtImmed;
wire [31:0] EX_Inst;
wire [1:0] EX_MemSize;
wire [31:0] EX_NextPC;
wire [31:0] EX_RS_IN;
wire [31:0] EX_RT;
wire [31:0] EX_RT_IN;
wire [4:0] EX_WriteReg;
wire [31:0] Four;
wire [31:0] four;
wire [1:0] Fwd_EX_RS;
wire [1:0] Fwd_EX_RT;
wire [31:0] Fwd_RS;
wire [31:0] Fwd_RT;
wire [1:0] ID_ALUOp;
wire [31:0] ID_ExtImmed;
wire [1:0] ID_ExtOp;
wire [31:0] ID_Inst;
wire [1:0] ID_MemSize;
wire [31:0] ID_NextPC;
wire [31:0] ID_RS;
wire [31:0] ID_RT;
wire [4:0] ID_WriteReg;
wire [31:0] IF_Inst;
wire [31:0] IF_NextPC;
wire [31:0] MEM_ALUOut;
wire [31:0] MEM_CPUDataIn;
wire [31:0] MEM_CPUDataOut;
wire [31:0] MEM_Inst;
wire [1:0] MEM_MemSize;
wire [4:0] MEM_WriteReg;
wire [31:0] PCNext;
wire [31:0] RD;
wire [4:0] thrityone;
wire [31:0] WB_ALUOut;
wire [31:0] WB_CPUDataIn;
wire [31:0] WB_Inst;
wire [4:0] WB_WriteReg;

// -------- Component instantiations -------//

// synopsys translate_off
`library("ALU","lib378")
// synopsys translate_on
MIPSALU ALU
(
	.A(AluA),
	.ALUOut(EX_ALUOut),
	.ALUctl(ALUCtl),
	.B(AluB),
	.CLK(CLK),
	.Ovfl(Overflow),
	.Zero(Zilch)
);



EXMEMReg EXMEMReg
(
	.CLK(CLK),
	.EX_ALUOut(EX_ALUOut),
	.EX_CPUDataOut(EX_RT),
	.EX_Inst(EX_Inst),
	.EX_Load(EX_Load),
	.EX_MemSize(EX_MemSize),
	.EX_RegWrite(EX_RegWrite),
	.EX_SignedLoad(EX_SignedLoad),
	.EX_Store(EX_Store),
	.EX_WriteReg(EX_WriteReg),
	.LoadEnable(Always),
	.MEM_ALUOut(MEM_ALUOut),
	.MEM_CPUDataOut(MEM_CPUDataOut),
	.MEM_Inst(MEM_Inst),
	.MEM_Load(MEM_Load),
	.MEM_MemSize(MEM_MemSize),
	.MEM_RegWrite(MEM_RegWrite),
	.MEM_SignedLoad(MEM_SignedLoad),
	.MEM_Store(MEM_Store),
	.MEM_WriteReg(MEM_WriteReg),
	.RESET(RESET)
);



IDEXReg IDEXReg
(
	.CLK(CLK),
	.Clear(IDEXReg_Clear),
	.EX_ALUOp(EX_ALUOp),
	.EX_ExtImmed(EX_ExtImmed),
	.EX_Inst(EX_Inst),
	.EX_JAL(EX_JAL),
	.EX_Load(EX_Load),
	.EX_MemSize(EX_MemSize),
	.EX_NextPC(EX_NextPC),
	.EX_RS_IN(EX_RS_IN),
	.EX_RT_IN(EX_RT_IN),
	.EX_RegWrite(EX_RegWrite),
	.EX_SignedLoad(EX_SignedLoad),
	.EX_SrcASel(EX_SrcASel),
	.EX_SrcBSel(EX_SrcBSel),
	.EX_Store(EX_Store),
	.EX_WriteReg(EX_WriteReg),
	.ID_ALUOp(ID_ALUOp),
	.ID_ExtImmed(ID_ExtImmed),
	.ID_Inst(ID_Inst),
	.ID_JAL(ID_JAL),
	.ID_Load(ID_Load),
	.ID_MemSize(ID_MemSize),
	.ID_NextPC(ID_NextPC),
	.ID_RS_OUT(Fwd_RS),
	.ID_RT_OUT(Fwd_RT),
	.ID_RegWrite(ID_RegWrite),
	.ID_SignedLoad(ID_SignedLoad),
	.ID_SrcASel(ID_SrcASel),
	.ID_SrcBSel(ID_SrcBSel),
	.ID_Store(ID_Store),
	.ID_WriteReg(ID_WriteReg),
	.LoadEnable(LoadEnable),
	.RESET(RESET)
);



IFIDReg IFIDReg
(
	.CLK(CLK),
	.ID_Inst(ID_Inst),
	.ID_NextPC(ID_NextPC),
	.IF_Inst(IF_Inst),
	.IF_NextPC(IF_NextPC),
	.LoadEnable(LoadEnable),
	.RESET(RESET)
);



MEMWBReg MEMWBReg
(
	.CLK(CLK),
	.LoadEnable(Always),
	.MEM_ALUOut(MEM_ALUOut),
	.MEM_CPUDataIn(MEM_CPUDataIn),
	.MEM_Inst(MEM_Inst),
	.MEM_Load(MEM_Load),
	.MEM_RegWrite(MEM_RegWrite),
	.MEM_WriteReg(MEM_WriteReg),
	.RESET(RESET),
	.WB_ALUOut(WB_ALUOut),
	.WB_CPUDataIn(WB_CPUDataIn),
	.WB_Inst(WB_Inst),
	.WB_Load(WB_Load),
	.WB_RegWrite(WB_RegWrite),
	.WB_WriteReg(WB_WriteReg)
);



// synopsys translate_off
`library("Regfile","lib378")
// synopsys translate_on
registerfile2
#(
	.INIT_FILE("$DSN\\src\\Assembly\\phase1.rif"))
Regfile
(
	.CLK(CLK),
	.Data1(ID_RS),
	.Data2(ID_RT),
	.Read1(ID_Inst[25:21]),
	.Read2(ID_Inst[20:16]),
	.RegWrite(WB_RegWrite),
	.WriteData(RD),
	.WriteReg(WB_WriteReg)
);



// synopsys translate_off
`library("U1","lib378")
// synopsys translate_on
ALUControl U1
(
	.ALUCtl(ALUCtl),
	.ALUOp(EX_ALUOp),
	.Func(EX_Inst[5:0]),
	.Opcode(EX_Inst[31:26])
);



// synopsys translate_off
`library("U10","lib378")
// synopsys translate_on
m32w_4_1_bot U10
(
	.in0(EX_RT_IN),
	.in1(four),
	.in2(MEM_ALUOut),
	.in3(RD),
	.out(EX_RT),
	.sel(Fwd_EX_RT)
);



// synopsys translate_off
`library("U11","lib378")
// synopsys translate_on
m32w_2_1_bot U11
(
	.in0(ID_RT),
	.in1(MEM_ALUOut),
	.out(Fwd_RT),
	.sel(Fwd_ID_RT)
);



// synopsys translate_off
`library("U12","lib378")
// synopsys translate_on
constant
#(
	.value(4))
U12
(
	.Value(four[31:0])
);



// synopsys translate_off
`library("U13","lib378")
// synopsys translate_on
m5w_2_1 U13
(
	.in0(ID_Inst[20:16]),
	.in1(thrityone),
	.out(BUS839),
	.sel(ID_JAL)
);



// synopsys translate_off
`library("U14","lib378")
// synopsys translate_on
constant
#(
	.value(31),
	.width(5))
U14
(
	.Value(thrityone[4:0])
);




Controller U15
(
	.AluOp(ID_ALUOp),
	.Branch(ID_Branch),
	.ExtOp(ID_ExtOp),
	.Func(ID_Inst[5:0]),
	.JAL(ID_JAL),
	.JR(ID_JR),
	.Jump(ID_Jump),
	.Load(ID_Load),
	.MemSize(ID_MemSize),
	.Op(ID_Inst[31:26]),
	.RegWrite(ID_RegWrite),
	.SignedLoad(ID_SignedLoad),
	.SrcASel(ID_SrcASel),
	.SrcBSel(ID_SrcBSel),
	.Store(ID_Store),
	.WriteToRD(ID_WriteToRD)
);



Comparator U16
(
	.ID_EQ(ID_EQ),
	.ID_RS(Fwd_RS),
	.ID_RT(Fwd_RT)
);



// synopsys translate_off
`library("U17","lib378")
// synopsys translate_on
m32w_4_1_top U17
(
	.in0(EX_RS_IN),
	.in1(EX_NextPC),
	.in2(MEM_ALUOut),
	.in3(RD),
	.out(BUS814),
	.sel(Fwd_EX_RS)
);



// synopsys translate_off
`library("U18","lib378")
// synopsys translate_on
m32w_2_1_top U18
(
	.in0(ID_RS),
	.in1(MEM_ALUOut),
	.out(Fwd_RS),
	.sel(Fwd_ID_RS)
);



ForwardingUnit U19
(
	.EX_Inst(EX_Inst[25:16]),
	.EX_JAL(EX_JAL),
	.Fwd_EX_RS(Fwd_EX_RS),
	.Fwd_EX_RT(Fwd_EX_RT),
	.Fwd_ID_RS(Fwd_ID_RS),
	.Fwd_ID_RT(Fwd_ID_RT),
	.ID_Branch(ID_Branch),
	.ID_Inst(ID_Inst[25:16]),
	.ID_JR(ID_JR),
	.MEM_RegWrite(MEM_RegWrite),
	.MEM_WriteReg(MEM_WriteReg),
	.WB_RegWrite(WB_RegWrite),
	.WB_WriteReg(WB_WriteReg)
);



// synopsys translate_off
`library("U2","lib378")
// synopsys translate_on
Extender U2
(
	.CTL(ID_ExtOp),
	.IN(ID_Inst[15:0]),
	.O(ID_ExtImmed)
);



HazardDetectionUnit U20
(
	.EX_Load(EX_Load),
	.EX_RegWrite(EX_RegWrite),
	.EX_WriteReg(EX_WriteReg),
	.IDEXReg_Clear(IDEXReg_Clear),
	.ID_Branch(ID_Branch),
	.ID_Inst(ID_Inst[25:16]),
	.ID_JR(ID_JR),
	.LoadEnable(LoadEnable),
	.MEM_Load(MEM_Load),
	.MEM_RegWrite(MEM_RegWrite),
	.MEM_WriteReg(MEM_WriteReg)
);



// synopsys translate_off
`library("U3","lib378")
// synopsys translate_on
m32w_2_1_bot U3
(
	.in0(EX_RT),
	.in1(EX_ExtImmed),
	.out(AluB),
	.sel(EX_SrcBSel)
);



// synopsys translate_off
`library("U4","lib378")
// synopsys translate_on
m32w_2_1_top U4
(
	.in0(BUS814),
	.in1(EX_ExtImmed),
	.out(AluA),
	.sel(EX_SrcASel)
);



// synopsys translate_off
`library("U5","lib378")
// synopsys translate_on
m32w_2_1_bot U5
(
	.in0(WB_ALUOut),
	.in1(WB_CPUDataIn),
	.out(RD),
	.sel(WB_Load)
);



// synopsys translate_off
`library("U6","lib378")
// synopsys translate_on
register_re U6
(
	.CLK(CLK),
	.D(PCNext[31:0]),
	.LD(LoadEnable),
	.Q(PCOut[31:0]),
	.RESET(RESET)
);



// synopsys translate_off
`library("U7","lib378")
// synopsys translate_on
constant U7
(
	.Value(Four[31:0])
);



// synopsys translate_off
`library("U8","lib378")
// synopsys translate_on
adder U8
(
	.InA(Four[31:0]),
	.InB(PCOut[31:0]),
	.Out(IF_NextPC[31:0])
);



PCAddressComputer U9
(
	.Branch(ID_Branch),
	.Inst(ID_Inst),
	.JR(ID_JR),
	.Jump(ID_Jump),
	.NextPC(IF_NextPC),
	.PCIn(PCOut),
	.PCOut(PCNext),
	.RS(Fwd_RS),
	.zero(ID_EQ)
);



// synopsys translate_off
`library("WriteRegMux","lib378")
// synopsys translate_on
m5w_2_1 WriteRegMux
(
	.in0(BUS839),
	.in1(ID_Inst[15:11]),
	.out(ID_WriteReg),
	.sel(ID_WriteToRD)
);



// ----------- Terminals assignment --------//
//	       ---- Input terminals ---         //
assign IF_Inst[31:0] = Inst[31:0];
assign MEM_CPUDataIn[31:0] = CPUDataIn[31:0];

//		   ---- Output terminals ---        //
assign ALUOut[31:0] = MEM_ALUOut[31:0];
assign CPUDataOut[31:0] = MEM_CPUDataOut[31:0];
assign Load = MEM_Load;
assign MemSize[1:0] = MEM_MemSize[1:0];
assign SignedLoad = MEM_SignedLoad;
assign Store = MEM_Store;

// ------------- Power assignment ----------//
assign Always = VCC;

endmodule 
