//-----------------------------------------------------------------------------
//
// Title       : No Title
// Design      : lab3-debug_dist
// Author      : cse
// Company     : uw
//
//-----------------------------------------------------------------------------
//
// File        : W:\cuteness\work\lab3-debug_dist\compile\test_board.v
// Generated   : Thu Apr 26 17:20:22 2007
// From        : W:\cuteness\work\lab3-debug_dist\src\test_board.bde
// By          : Bde2Verilog ver. 2.01
//
//-----------------------------------------------------------------------------
//
// Description : 
//
//-----------------------------------------------------------------------------

`ifdef _VCP
`else
`define library
`define synthesis
`endif


// ---------- Design Unit Header ---------- //
`timescale 1ps / 1ps

// ---------- Synthesis black box modules ---------- //
// synopsys translate_off
// synthesis translate_on
`ifdef synthesis
// synthesis translate_off
// synopsys translate_on

// synopsys translate_off
// synthesis translate_on
`ifdef INC_OBUF_V
`else
`define INC_OBUF_V 1
// synthesis translate_off
// synopsys translate_on
module OBUF ( I ,O ); /*synthesis syn_black_box*/
parameter CAPACITANCE = "DONT_CARE" ;
parameter DRIVE = 12 ;
parameter IOSTANDARD = "DEFAULT" ;
parameter SLEW = "SLOW" ;
	input I ;
	output O ;
endmodule
// synopsys translate_off
// synthesis translate_on
`endif
// synthesis translate_off
// synopsys translate_on

// synopsys translate_off
// synthesis translate_on
`endif
// synthesis translate_off
// synopsys translate_on


module test_board (PB_DOWN,PB_ENTER,PB_LEFT,PB_RIGHT,PB_UP,RS232_RTS_IN,RS232_RX_DATA,SW_0,SW_3,SYSTEM_CLOCK,
LA_GND0,LA_GND1,LA_TRIG,LED_0,LED_1,LED_2,LED_3,RS232_CTS_OUT,RS232_TX_DATA,VGA_COMP_SYNCH,
VGA_HSYNCH,VGA_OUT_BLANK_Z,VGA_OUT_PIXEL_CLOCK,VGA_VSYNCH,LA_A0,LA_A1,VGA_OUT_BLUE,VGA_OUT_GREEN,VGA_OUT_RED) ;

// ---- User defined diagram parameters --- //

parameter BIOS_FILE="Assembly\\bios_new.hex";

parameter REGINIT="$DSN\\src\\Assembly\\phase1.rif";

parameter DATAINIT="$DSN\\src\\Assembly\\phase1a.dat";


// --- User defined diagram declarations -- //
// Enter your code here
//synopsys translate_off
defparam MemorySystem.BIOS_INIT_FILE=BIOS_FILE;
defparam CPU.Regfile.INIT_FILE = REGINIT;
//defparam MemorySystem.DATA_INIT_FILE=DATAINIT;
//defparam MemorySystem.STACK_INIT_FILE="$DSN\\src\\zero.hex";
`library("glbl","ovi_unisim")
glbl glbl();
//synopsys translate_on

// ------------ Port declarations --------- //
input PB_DOWN;
wire PB_DOWN;
input PB_ENTER;
wire PB_ENTER;
input PB_LEFT;
wire PB_LEFT;
input PB_RIGHT;
wire PB_RIGHT;
input PB_UP;
wire PB_UP;
input RS232_RTS_IN;
wire RS232_RTS_IN;
input RS232_RX_DATA;
wire RS232_RX_DATA;
input SW_0;
wire SW_0;
input SW_3;
wire SW_3;
input SYSTEM_CLOCK;
wire SYSTEM_CLOCK;
output LA_GND0;
wire LA_GND0;
output LA_GND1;
wire LA_GND1;
output LA_TRIG;
wire LA_TRIG;
output LED_0;
wire LED_0;
output LED_1;
wire LED_1;
output LED_2;
wire LED_2;
output LED_3;
wire LED_3;
output RS232_CTS_OUT;
wire RS232_CTS_OUT;
output RS232_TX_DATA;
wire RS232_TX_DATA;
output VGA_COMP_SYNCH;
wire VGA_COMP_SYNCH;
output VGA_HSYNCH;
wire VGA_HSYNCH;
output VGA_OUT_BLANK_Z;
wire VGA_OUT_BLANK_Z;
output VGA_OUT_PIXEL_CLOCK;
wire VGA_OUT_PIXEL_CLOCK;
output VGA_VSYNCH;
wire VGA_VSYNCH;
output [7:0] LA_A0;
wire [7:0] LA_A0;
output [7:0] LA_A1;
wire [7:0] LA_A1;
output [7:0] VGA_OUT_BLUE;
wire [7:0] VGA_OUT_BLUE;
output [7:0] VGA_OUT_GREEN;
wire [7:0] VGA_OUT_GREEN;
output [7:0] VGA_OUT_RED;
wire [7:0] VGA_OUT_RED;

// ----------- Signal declarations -------- //
wire CharWE;
wire CLK;
wire ColorWE;
wire CTS_OUT;
supply0 GND;
wire IODev1WE;
wire IODev2WE;
wire IODev3WE;
wire IODev4WE;
wire Load;
wire NET465;
wire Reset;
wire RTS_IN;
wire RX_DATA;
wire SerialClock;
wire SignedLoad;
wire Store;
wire TX_DATA;
wire VGAClock;
wire [31:0] ALUOut;
wire [4:0] Buttons;
wire [31:0] CPUDataIn;
wire [31:0] CPUDataOut;
wire [31:0] Inst;
wire [31:0] IODev1Input;
wire [31:0] IODev2Input;
wire [31:0] IODev3Input;
wire [1:0] MemSize;
wire [3:0] MMapLEDs;
wire [31:0] PCOut;
wire [31:0] SerialInput;

// -------- Component instantiations -------//

// synopsys translate_off
`library("BoardIO","lib378")
// synopsys translate_on
MemoryMappedBoardIO BoardIO
(
	.CLK(CLK),
	.IOAddress(ALUOut[5:0]),
	.IOData(CPUDataOut),
	.IODataOut(IODev1Input),
	.IOWE(IODev2WE),
	.Reset(Reset),
	.nButtonInputs(Buttons),
	.nLEDBus(MMapLEDs)
);



cpu CPU
(
	.ALUOut(ALUOut),
	.CLK(CLK),
	.CPUDataIn(CPUDataIn),
	.CPUDataOut(CPUDataOut),
	.Inst(Inst),
	.Load(Load),
	.MemSize(MemSize),
	.PCOut(PCOut),
	.RESET(Reset),
	.SignedLoad(SignedLoad),
	.Store(Store)
);



// synopsys translate_off
`library("MemorySystem","lib378")
// synopsys translate_on
Memory_Toplevel MemorySystem
(
	.CLK(CLK),
	.CharWE(CharWE),
	.ColorWE(ColorWE),
	.DataAddress(ALUOut),
	.DataIn(CPUDataOut),
	.DataOut(CPUDataIn),
	.IODev1Input(SerialInput),
	.IODev1WE(IODev1WE),
	.IODev2Input(IODev1Input),
	.IODev2WE(IODev2WE),
	.IODev3Input(IODev2Input),
	.IODev3WE(IODev3WE),
	.IODev4Input(IODev3Input),
	.IODev4WE(IODev4WE),
	.InstrAddress(PCOut),
	.Instruction(Inst),
	.SignedLoad(SignedLoad),
	.Size(MemSize),
	.WriteEnable(Store)
);



// synopsys translate_off
`library("U1","VIRTEX2P")
// synopsys translate_on
OBUF U1
(
	.I(CLK),
	.O(LA_TRIG)
);



MemoryMappedSerial_TF U2
(
	.DataOut(SerialInput),
	.InAddress(ALUOut[5:0]),
	.InData(CPUDataOut),
	.InWE(IODev1WE),
	.RS232_RTS_IN(RTS_IN),
	.RS_232_CTS_OUT(CTS_OUT),
	.RS_232_RX_DATA(RX_DATA),
	.RS_232_TX_DATA(TX_DATA),
	.Size(MemSize),
	.clk(SerialClock),
	.reset(Reset)
);



// synopsys translate_off
`library("U7","lib378")
// synopsys translate_on
ClockSystem U7
(
	.CLK(CLK),
	.Hard_Reset_Switch(SW_0),
	.Reset(Reset),
	.SYSTEM_CLOCK(SYSTEM_CLOCK),
	.SerialClock(SerialClock),
	.Soft_Reset_Switch(SW_3),
	.VGAClock(VGAClock)
);



// synopsys translate_off
`library("VGACTL","lib378")
// synopsys translate_on
VGA_Output VGACTL
(
	.AddressIn(ALUOut[12:0]),
	.CLK(CLK),
	.CharWE(CharWE),
	.ColorWE(ColorWE),
	.DataIn(CPUDataOut[7:0]),
	.Reset(Reset),
	.VGAClock(VGAClock),
	.VGA_COMP_SYNCH(VGA_COMP_SYNCH),
	.VGA_HSYNCH(VGA_HSYNCH),
	.VGA_OUT_BLANK_Z(VGA_OUT_BLANK_Z),
	.VGA_OUT_BLUE(VGA_OUT_BLUE),
	.VGA_OUT_GREEN(VGA_OUT_GREEN),
	.VGA_OUT_PIXEL_CLOCK(VGA_OUT_PIXEL_CLOCK),
	.VGA_OUT_RED(VGA_OUT_RED),
	.VGA_VSYNCH(VGA_VSYNCH)
);



// ----------- Terminals assignment --------//
//	       ---- Input terminals ---         //
assign Buttons[0] = PB_UP;
assign Buttons[1] = PB_DOWN;
assign Buttons[2] = PB_LEFT;
assign Buttons[3] = PB_RIGHT;
assign Buttons[4] = PB_ENTER;
assign RTS_IN = RS232_RTS_IN;
assign RX_DATA = RS232_RX_DATA;

//		   ---- Output terminals ---        //
assign LA_A0[7:0] = PCOut[9:2];
assign LA_A1[7:0] = CPUDataOut[7:0];
assign LA_GND0 = NET465;
assign LA_GND1 = NET465;
assign LED_0 = MMapLEDs[0];
assign LED_1 = MMapLEDs[1];
assign LED_2 = MMapLEDs[2];
assign LED_3 = MMapLEDs[3];
assign RS232_CTS_OUT = CTS_OUT;
assign RS232_TX_DATA = TX_DATA;

// ------------- Ground assignment ---------//
assign NET465 = GND;

endmodule 
